git-stash.sh 11.6 KB
Newer Older
しらいしななこ 已提交
1 2 3
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

4 5
dashless=$(basename "$0" | sed -e 's/-/ /')
USAGE="list [<options>]
S
Stephen Boyd 已提交
6 7 8
   or: $dashless show [<stash>]
   or: $dashless drop [-q|--quiet] [<stash>]
   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9
   or: $dashless branch <branchname> [<stash>]
10 11
   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
		       [-u|--include-untracked] [-a|--all] [<message>]]
12
   or: $dashless clear"
しらいしななこ 已提交
13

14
SUBDIRECTORY_OK=Yes
15
OPTIONS_SPEC=
16
START_DIR=`pwd`
しらいしななこ 已提交
17 18
. git-sh-setup
require_work_tree
19
cd_to_toplevel
しらいしななこ 已提交
20 21

TMP="$GIT_DIR/.git-stash.$$"
22 23
TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
trap 'rm -f "$TMP-"* "$TMPindex"' 0
しらいしななこ 已提交
24 25 26

ref_stash=refs/stash

T
Thomas Rast 已提交
27 28 29 30 31 32 33 34
if git config --get-colorbool color.interactive; then
       help_color="$(git config --get-color color.interactive.help 'red bold')"
       reset_color="$(git config --get-color '' reset)"
else
       help_color=
       reset_color=
fi

しらいしななこ 已提交
35
no_changes () {
36
	git diff-index --quiet --cached HEAD --ignore-submodules -- &&
37 38 39 40 41 42 43 44
	git diff-files --quiet --ignore-submodules &&
	(test -z "$untracked" || test -z "$(untracked_files)")
}

untracked_files () {
	excl_opt=--exclude-standard
	test "$untracked" = "all" && excl_opt=
	git ls-files -o -z $excl_opt
しらいしななこ 已提交
45 46 47
}

clear_stash () {
48 49 50 51
	if test $# != 0
	then
		die "git stash clear with parameters is unimplemented"
	fi
52
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
53
	then
E
Emil Medve 已提交
54
		git update-ref -d $ref_stash $current
55
	fi
しらいしななこ 已提交
56 57
}

J
Junio C Hamano 已提交
58
create_stash () {
59
	stash_msg="$1"
60
	untracked="$2"
61

62
	git update-index -q --refresh
しらいしななこ 已提交
63 64 65 66
	if no_changes
	then
		exit 0
	fi
67

しらいしななこ 已提交
68
	# state of the base commit
69
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ 已提交
70
	then
J
Jeff King 已提交
71
		head=$(git rev-list --oneline -n 1 HEAD --)
しらいしななこ 已提交
72 73 74 75
	else
		die "You do not have the initial commit yet"
	fi

76
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ 已提交
77 78 79 80 81 82 83 84
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
85
	i_tree=$(git write-tree) &&
86
	i_commit=$(printf 'index on %s\n' "$msg" |
87
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ 已提交
88 89
		die "Cannot save the current index state"

90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108
	if test -n "$untracked"
	then
		# Untracked files are stored by themselves in a parentless commit, for
		# ease of unpacking later.
		u_commit=$(
			untracked_files | (
				export GIT_INDEX_FILE="$TMPindex"
				rm -f "$TMPindex" &&
				git update-index -z --add --remove --stdin &&
				u_tree=$(git write-tree) &&
				printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree  &&
				rm -f "$TMPindex"
		) ) || die "Cannot save the untracked files"

		untracked_commit_option="-p $u_commit";
	else
		untracked_commit_option=
	fi

T
Thomas Rast 已提交
109 110 111 112 113
	if test -z "$patch_mode"
	then

		# state of the working tree
		w_tree=$( (
114 115
			git read-tree --index-output="$TMPindex" -m $i_tree &&
			GIT_INDEX_FILE="$TMPindex" &&
T
Thomas Rast 已提交
116
			export GIT_INDEX_FILE &&
117
			git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
T
Thomas Rast 已提交
118
			git write-tree &&
119
			rm -f "$TMPindex"
T
Thomas Rast 已提交
120 121 122 123 124
		) ) ||
			die "Cannot save the current worktree state"

	else

125
		rm -f "$TMP-index" &&
T
Thomas Rast 已提交
126 127 128 129 130 131 132 133
		GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&

		# find out what the user wants
		GIT_INDEX_FILE="$TMP-index" \
			git add--interactive --patch=stash -- &&

		# state of the working tree
		w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
しらいしななこ 已提交
134 135
		die "Cannot save the current worktree state"

T
Thomas Rast 已提交
136 137 138 139 140 141 142 143 144
		git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
		test -s "$TMP-patch" ||
		die "No changes selected"

		rm -f "$TMP-index" ||
		die "Cannot remove temporary index (can't happen)"

	fi

しらいしななこ 已提交
145
	# create the stash
146 147 148 149 150 151 152
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
153
		git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
しらいしななこ 已提交
154
		die "Cannot record working tree state"
J
Junio C Hamano 已提交
155
}
しらいしななこ 已提交
156

J
Junio C Hamano 已提交
157
save_stash () {
158
	keep_index=
T
Thomas Rast 已提交
159
	patch_mode=
160
	untracked=
S
Stephen Boyd 已提交
161 162 163
	while test $# != 0
	do
		case "$1" in
164
		-k|--keep-index)
S
Stephen Boyd 已提交
165 166
			keep_index=t
			;;
T
Thomas Rast 已提交
167
		--no-keep-index)
168
			keep_index=n
T
Thomas Rast 已提交
169 170 171
			;;
		-p|--patch)
			patch_mode=t
172 173
			# only default to keep if we don't already have an override
			test -z "$keep_index" && keep_index=t
S
Stephen Boyd 已提交
174 175 176 177
			;;
		-q|--quiet)
			GIT_QUIET=t
			;;
178 179 180 181 182 183
		-u|--include-untracked)
			untracked=untracked
			;;
		-a|--all)
			untracked=all
			;;
184 185 186 187 188 189
		--)
			shift
			break
			;;
		-*)
			echo "error: unknown option for 'stash save': $1"
190
			echo "       To provide a message, use git stash save -- '$1'"
191 192
			usage
			;;
S
Stephen Boyd 已提交
193 194 195 196
		*)
			break
			;;
		esac
197
		shift
S
Stephen Boyd 已提交
198
	done
199

200 201
	if test -n "$patch_mode" && test -n "$untracked"
	then
202
	    die "Can't use --patch and --include-untracked or --all at the same time"
203 204
	fi

205
	stash_msg="$*"
J
Junio C Hamano 已提交
206

207
	git update-index -q --refresh
J
Junio C Hamano 已提交
208 209
	if no_changes
	then
S
Stephen Boyd 已提交
210
		say 'No local changes to save'
J
Junio C Hamano 已提交
211 212 213 214 215
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

216
	create_stash "$stash_msg" $untracked
E
Emil Medve 已提交
217 218 219

	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"
しらいしななこ 已提交
220

221
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ 已提交
222
		die "Cannot save the current status"
S
Stephen Boyd 已提交
223
	say Saved working directory and index state "$stash_msg"
224

T
Thomas Rast 已提交
225
	if test -z "$patch_mode"
226
	then
T
Thomas Rast 已提交
227
		git reset --hard ${GIT_QUIET:+-q}
228 229 230 231 232
		test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
		if test -n "$untracked"
		then
			git clean --force --quiet $CLEAN_X_OPTION
		fi
T
Thomas Rast 已提交
233

234
		if test "$keep_index" = "t" && test -n $i_tree
T
Thomas Rast 已提交
235 236 237 238 239 240 241
		then
			git read-tree --reset -u $i_tree
		fi
	else
		git apply -R < "$TMP-patch" ||
		die "Cannot remove worktree changes"

242
		if test "$keep_index" != "t"
T
Thomas Rast 已提交
243 244 245
		then
			git reset
		fi
246
	fi
しらいしななこ 已提交
247 248
}

249
have_stash () {
250
	git rev-parse --verify $ref_stash >/dev/null 2>&1
251 252
}

しらいしななこ 已提交
253
list_stash () {
254
	have_stash || return 0
255
	git log --format="%gd: %gs" -g "$@" $ref_stash --
しらいしななこ 已提交
256 257 258
}

show_stash () {
259
	assert_stash_like "$@"
260

261
	git diff ${FLAGS:---stat} $b_commit $w_commit
しらいしななこ 已提交
262 263
}

264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281
#
# Parses the remaining options looking for flags and
# at most one revision defaulting to ${ref_stash}@{0}
# if none found.
#
# Derives related tree and commit objects from the
# revision, if one is found.
#
# stash records the work tree, and is a merge between the
# base commit (first parent) and the index tree (second parent).
#
#   REV is set to the symbolic version of the specified stash-like commit
#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
#   s is set to the SHA1 of the stash commit
#   w_commit is set to the commit containing the working tree
#   b_commit is set to the base commit
#   i_commit is set to the commit containing the index tree
282
#   u_commit is set to the commit containing the untracked files tree
283 284 285
#   w_tree is set to the working tree
#   b_tree is set to the base tree
#   i_tree is set to the index tree
286
#   u_tree is set to the untracked files tree
287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310
#
#   GIT_QUIET is set to t if -q is specified
#   INDEX_OPTION is set to --index if --index is specified.
#   FLAGS is set to the remaining flags
#
# dies if:
#   * too many revisions specified
#   * no revision is specified and there is no stash stack
#   * a revision is specified which cannot be resolve to a SHA1
#   * a non-existent stash reference is specified
#

parse_flags_and_rev()
{
	test "$PARSE_CACHE" = "$*" && return 0 # optimisation
	PARSE_CACHE="$*"

	IS_STASH_LIKE=
	IS_STASH_REF=
	INDEX_OPTION=
	s=
	w_commit=
	b_commit=
	i_commit=
311
	u_commit=
312 313 314
	w_tree=
	b_tree=
	i_tree=
315
	u_tree=
316

317
	REV=$(git rev-parse --no-flags --symbolic "$@") || exit 1
318 319

	FLAGS=
J
Jon Seymour 已提交
320
	for opt
321
	do
J
Jon Seymour 已提交
322 323 324 325
		case "$opt" in
			-q|--quiet)
				GIT_QUIET=-t
			;;
326 327 328
			--index)
				INDEX_OPTION=--index
			;;
J
Jon Seymour 已提交
329 330
			-*)
				FLAGS="${FLAGS}${FLAGS:+ }$opt"
331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362
			;;
		esac
	done

	set -- $REV

	case $# in
		0)
			have_stash || die "No stash found."
			set -- ${ref_stash}@{0}
		;;
		1)
			:
		;;
		*)
			die "Too many revisions specified: $REV"
		;;
	esac

	REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"

	i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
	set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
	s=$1 &&
	w_commit=$1 &&
	b_commit=$2 &&
	w_tree=$3 &&
	b_tree=$4 &&
	i_tree=$5 &&
	IS_STASH_LIKE=t &&
	test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
	IS_STASH_REF=t
363 364 365

	u_commit=$(git rev-parse --quiet --verify $REV^3 2>/dev/null) &&
	u_tree=$(git rev-parse $REV^3: 2>/dev/null)
366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385
}

is_stash_like()
{
	parse_flags_and_rev "$@"
	test -n "$IS_STASH_LIKE"
}

assert_stash_like() {
	is_stash_like "$@" || die "'$*' is not a stash-like commit"
}

is_stash_ref() {
	is_stash_like "$@" && test -n "$IS_STASH_REF"
}

assert_stash_ref() {
	is_stash_ref "$@" || die "'$*' is not a stash reference"
}

しらいしななこ 已提交
386
apply_stash () {
S
Stephen Boyd 已提交
387

388
	assert_stash_like "$@"
しらいしななこ 已提交
389

390
	git update-index -q --refresh || die 'unable to refresh index'
391 392 393 394 395

	# current index state
	c_tree=$(git write-tree) ||
		die 'Cannot apply a stash in the middle of a merge'

J
Junio C Hamano 已提交
396
	unstashed_index_tree=
397
	if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
398
			test "$c_tree" != "$i_tree"
J
Junio C Hamano 已提交
399
	then
400
		git diff-tree --binary $s^2^..$s^2 | git apply --cached
401 402
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
403
		unstashed_index_tree=$(git write-tree) ||
404 405
			die 'Could not save index tree'
		git reset
J
Junio C Hamano 已提交
406
	fi
407

408 409 410 411 412 413 414 415
	if test -n "$u_tree"
	then
		GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
		GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
		rm -f "$TMPindex" ||
		die 'Could not restore untracked files from stash'
	fi

しらいしななこ 已提交
416 417 418 419 420 421 422
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

S
Stephen Boyd 已提交
423 424
	if test -n "$GIT_QUIET"
	then
425
		GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
S
Stephen Boyd 已提交
426
	fi
427
	if git merge-recursive $b_tree -- $c_tree $w_tree
しらいしななこ 已提交
428 429
	then
		# No conflict
J
Junio C Hamano 已提交
430 431 432
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
433 434
		else
			a="$TMP-added" &&
435
			git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
436 437 438 439
			git read-tree --reset $c_tree &&
			git update-index --add --stdin <"$a" ||
				die "Cannot unstage modified files"
			rm -f "$a"
J
Junio C Hamano 已提交
440
		fi
S
Stephen Boyd 已提交
441 442 443 444 445
		squelch=
		if test -n "$GIT_QUIET"
		then
			squelch='>/dev/null 2>&1'
		fi
446
		(cd "$START_DIR" && eval "git status $squelch") || :
しらいしななこ 已提交
447 448
	else
		# Merge conflict; keep the exit status from merge-recursive
449
		status=$?
450
		if test -n "$INDEX_OPTION"
J
Junio C Hamano 已提交
451 452 453
		then
			echo >&2 'Index was not unstashed.'
		fi
454
		exit $status
しらいしななこ 已提交
455 456 457
	fi
}

458 459 460 461 462 463 464
pop_stash() {
	assert_stash_ref "$@"

	apply_stash "$@" &&
	drop_stash "$@"
}

465
drop_stash () {
466
	assert_stash_ref "$@"
467

468 469
	git reflog delete --updateref --rewrite "${REV}" &&
		say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
470 471

	# clear_stash if we just dropped the last stash entry
472
	git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
473 474
}

475 476 477
apply_to_branch () {
	test -n "$1" || die 'No branch name specified'
	branch=$1
478
	shift 1
479

480 481 482 483
	set -- --index "$@"
	assert_stash_like "$@"

	git checkout -b $branch $REV^ &&
484 485 486
	apply_stash "$@" && {
		test -z "$IS_STASH_REF" || drop_stash "$@"
	}
487 488
}

489
PARSE_CACHE='--not-parsed'
490 491 492 493 494 495 496 497 498 499 500 501
# The default command is "save" if nothing but options are given
seen_non_option=
for opt
do
	case "$opt" in
	-*) ;;
	*) seen_non_option=t; break ;;
	esac
done

test -n "$seen_non_option" || set "save" "$@"

しらいしななこ 已提交
502 503
# Main command set
case "$1" in
504 505
list)
	shift
しらいしななこ 已提交
506 507 508 509 510 511
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
512 513
save)
	shift
514
	save_stash "$@"
515
	;;
しらいしななこ 已提交
516 517 518 519 520
apply)
	shift
	apply_stash "$@"
	;;
clear)
521 522
	shift
	clear_stash "$@"
しらいしななこ 已提交
523
	;;
J
Junio C Hamano 已提交
524 525 526 527 528 529 530
create)
	if test $# -gt 0 && test "$1" = create
	then
		shift
	fi
	create_stash "$*" && echo "$w_commit"
	;;
531 532 533 534
drop)
	shift
	drop_stash "$@"
	;;
535 536
pop)
	shift
537
	pop_stash "$@"
538
	;;
539 540 541 542
branch)
	shift
	apply_to_branch "$@"
	;;
しらいしななこ 已提交
543
*)
544 545
	case $# in
	0)
546
		save_stash &&
S
Stephen Boyd 已提交
547
		say '(To restore them type "git stash apply")'
548 549
		;;
	*)
550
		usage
551
	esac
552
	;;
しらいしななこ 已提交
553
esac